#include "stdafx.h"

#include "AnimData.h"


CAnimData::CAnimData(FLOAT fAngleX, FLOAT fAngleY, FLOAT fAngleZ, CVect3D vecTrans, WORD wTRAngle1, WORD wTRAngle2) : 
    m_vecTrans(vecTrans), m_wTRAngle1(wTRAngle1), m_wTRAngle2(wTRAngle2)
{
    fAngleX *= 0.5f;
    fAngleY *= 0.5f;
    fAngleZ *= 0.5f;

    CVect3D vec3dAxis1X(sin(fAngleX),0,0);
    CVect3D vec3dAxis1Y(0,sin(fAngleY),0);
    CVect3D vec3dAxis1Z(0,0,sin(fAngleZ));

    CQuaternion q1x(vec3dAxis1X,cos(fAngleX));
    CQuaternion q1y(vec3dAxis1Y,cos(fAngleY));
    CQuaternion q1z(vec3dAxis1Z,cos(fAngleZ));

    m_Quat = q1y * q1x * q1z;
}


void    CAnimData::vInterpolate(const CAnimData& Data1, const CAnimData& Data2, CAnimData* lpDataRes, FLOAT fInterpFactor)
{
    CQuaternion  q2 = Data2.m_Quat;
    
    if((Data1.m_Quat - Data2.m_Quat).fLength2() > (Data1.m_Quat + Data2.m_Quat).fLength2()) q2 = -q2;

    lpDataRes->m_Quat       = quatSlerp(Data1.m_Quat, q2, fInterpFactor);
    lpDataRes->m_vecTrans   = Data1.m_vecTrans * ((FLOAT)1.0 - fInterpFactor) + Data2.m_vecTrans * fInterpFactor;
}

