#if !defined(AFX_EDITMOVEABLE_H__D9E3B0C1_B8F0_11D1_AA68_00105A49000B__INCLUDED_)
#define AFX_EDITMOVEABLE_H__D9E3B0C1_B8F0_11D1_AA68_00105A49000B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// EditMoveable.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CEditMoveable form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

#include "OpenGLWnd1.h"

class CHandleMoveable;
class CToolboxMoveable;

class CEditMoveable : public CFormView
{
protected:
	CEditMoveable();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CEditMoveable)

// Form Data
public:
	//{{AFX_DATA(CEditMoveable)
	enum { IDD = IDD_EDIT_MOVEABLE };
	//}}AFX_DATA

// Attributes
public:

// Operations
public:

    void    vSetDataTypeHandler(CHandleMoveable* lpHandler,bool boForceNewMoveable = false);
    BOOL    boOnIdle();
    void    vReloadTextures();

    void    vRedrawOpenGLWnd() { if(m_OpenGLWnd) m_OpenGLWnd->InvalidateRect(NULL,FALSE); }
    void    vSetAutomaticCamera(bool boAutomaticCamera) { if(m_OpenGLWndCreated) m_OpenGLWnd->vSetAutomaticCamera(boAutomaticCamera); }
    void    vSetShowAxis(bool boShow) { if(m_OpenGLWndCreated) m_OpenGLWnd->vSetShowAxis(boShow); }
    void    vSetBkgColor(COLORREF BkgColor) { if(m_OpenGLWndCreated) m_OpenGLWnd->vSetBkgColor(BkgColor); }
    void    vSetAnimation(DWORD dwNumAnim) { if(m_OpenGLWndCreated) m_OpenGLWnd->vSetMoveableAnimation(dwNumAnim); }
    void    vSetAnimationType(bool boChainAnimations,bool boResetMoveable = true) { if(m_OpenGLWndCreated) m_OpenGLWnd->vSetAnimationType(boChainAnimations,boResetMoveable); }
    void    vSetAutomaticAnim(bool boAutomaticAnim) { if(m_OpenGLWndCreated) m_OpenGLWnd->vSetAutomaticAnim(boAutomaticAnim); }
    void    vSetAnimOverallSpeed(float fSpeed) { if(m_OpenGLWndCreated) m_OpenGLWnd->vSetAnimOverallSpeed(fSpeed); }
    void    vSetAnimCurFrame(DWORD dwNumFrame) { if(m_OpenGLWndCreated) m_OpenGLWnd->vSetAnimCurFrame(dwNumFrame); }
    void    vSetAnimCurKey(DWORD dwNumKey) { if(m_OpenGLWndCreated) m_OpenGLWnd->vSetAnimCurKey(dwNumKey); }
    void    vSetAnimInterp(bool boOk) { if(m_OpenGLWndCreated) m_OpenGLWnd->vSetAnimInterp(boOk); }
    void    vChangeAnimInterp(int iDir) { if(m_OpenGLWndCreated) m_OpenGLWnd->vChangeAnimInterp(iDir); }
    void    vSetAnimInterp(float fInterp) { if(m_OpenGLWndCreated) m_OpenGLWnd->vSetAnimInterp(fInterp); }

    void    vRelease();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CEditMoveable)
	public:
	virtual void OnInitialUpdate();
	virtual void OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnDraw(CDC* pDC);
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CEditMoveable();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CEditMoveable)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:

    void    vCreateOpenGLWnd();
    void    vCheckKeys(float fFrameRate);

    CHandleMoveable*    m_lpDataHandler;
    COpenGLWnd*         m_OpenGLWnd;
    bool                m_OpenGLWndCreated;
    CToolboxMoveable*   m_lpToolbox;
    DWORD               m_dwNumSelectedMesh;

    friend class CToolboxMoveable;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_EDITMOVEABLE_H__D9E3B0C1_B8F0_11D1_AA68_00105A49000B__INCLUDED_)
