#if !defined(AFX_EDITSPRITE_H__4D27A179_F953_4A61_80EC_6E5208332689__INCLUDED_)
#define AFX_EDITSPRITE_H__4D27A179_F953_4A61_80EC_6E5208332689__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// EditSprite.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CEditSprite form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

#include "OpenGLWnd1.h"

class CHandleSprite;
class CToolboxSprite;

class CEditSprite : public CFormView
{
protected:
	CEditSprite();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CEditSprite)

// Form Data
public:
	//{{AFX_DATA(CEditSprite)
	enum { IDD = IDD_EDIT_SPRITE };
	//}}AFX_DATA

// Attributes
public:

// Operations
public:

    void    vSetDataTypeHandler(CHandleSprite* lpHandler);
    void    vReloadTextures();
    BOOL    boOnIdle();

    void    vRedrawOpenGLWnd() { if(m_OpenGLWnd) m_OpenGLWnd->InvalidateRect(NULL,FALSE); }
    void    vSetBkgColor(COLORREF BkgColor) { if(m_OpenGLWndCreated) m_OpenGLWnd->vSetBkgColor(BkgColor); }
    void    vSetSprSeqOverallSpeed(float fSpeed) { if(m_OpenGLWndCreated) m_OpenGLWnd->vSetSprSeqOverallSpeed(fSpeed); }
    void    vSetSprSeqShowBorder(bool boShow) {  if(m_OpenGLWndCreated) m_OpenGLWnd->vSetSprSeqShowBorder(boShow); }
    void    vSetSprSeqTypeAnimated(bool boAnimated) {  if(m_OpenGLWndCreated) m_OpenGLWnd->vSetSprSeqTypeAnimated(boAnimated); }
    void    vSetSprSeqListWidth(float fListWidth) { if(m_OpenGLWndCreated) m_OpenGLWnd->vSetSprSeqListWidth(fListWidth); }

    void    vRelease();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CEditSprite)
	public:
	virtual void OnInitialUpdate();
	virtual void OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnDraw(CDC* pDC);
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CEditSprite();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CEditSprite)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:

    void    vCreateOpenGLWnd();

    CHandleSprite*      m_lpDataHandler;
    COpenGLWnd*         m_OpenGLWnd;
    bool                m_OpenGLWndCreated;
    CToolboxSprite*     m_lpToolbox;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_EDITSPRITE_H__4D27A179_F953_4A61_80EC_6E5208332689__INCLUDED_)
