// ExportMvbl.cpp : implementation file
//

#include "stdafx.h"
#include "trviewer.h"
#include "AnimData.h"
#include "AnimKey.h"
#include "AnimTrack.h"
#include "AnimMgr.h"
#include "TRAnimTrack.h"
#include "ExportMvbl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CExportMvbl dialog


CExportMvbl::CExportMvbl(CAnimMgr* lpAnimMgr, DWORD dwSelectTrack, CWnd* pParent /*=NULL*/)
	: CDialog(CExportMvbl::IDD, pParent)
{
	//{{AFX_DATA_INIT(CExportMvbl)
	m_boExportAnim = FALSE;
	//}}AFX_DATA_INIT
    m_lpAnimMgr     = lpAnimMgr;
    m_dwSelectTrack = dwSelectTrack;
}


void CExportMvbl::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CExportMvbl)
	DDX_Control(pDX, IDC_EXPORT_NUMANIM, m_ListAnims);
	DDX_Check(pDX, IDC_EXPORT_ANIM, m_boExportAnim);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CExportMvbl, CDialog)
	//{{AFX_MSG_MAP(CExportMvbl)
	ON_BN_CLICKED(IDC_EXPORT_ANIM, OnExportAnim)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CExportMvbl message handlers

void CExportMvbl::OnExportAnim() 
{
    UpdateData( TRUE );
    
    if( m_boExportAnim )
        {
        m_ListAnims.EnableWindow( TRUE );
        }
    else
        {
        m_ListAnims.EnableWindow( FALSE );
        }	
}


void    CExportMvbl::OnOK()
{
    UpdateData( TRUE );

    if( !m_boExportAnim ) m_dwSelectTrack = -1;
    else m_dwSelectTrack = m_ListAnims.GetItemData( m_ListAnims.GetCurSel() );

    CDialog::OnOK();
}


BOOL CExportMvbl::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
    m_ListAnims.EnableWindow( FALSE );
    m_ListAnims.ResetContent();

    // Build the anim list (combo)
    DWORD       dwNumAnims = m_lpAnimMgr->dwGetNumTracks();
    DWORD       dwNumAnim = 0;

    if( m_dwSelectTrack >= dwNumAnims ) m_dwSelectTrack = dwNumAnims - 1;

    while(dwNumAnims--)
        {
        CString s;

        s.Format(_T("Animation #%.3d"),dwNumAnim + 1);

        int iIndex = m_ListAnims.AddString(s);

        m_ListAnims.SetItemData(iIndex, dwNumAnim);

        dwNumAnim++;
        }

    m_ListAnims.SetCurSel( m_dwSelectTrack );

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
