#pragma once

class CFileTree;

//
//
//
class CHandleBase
{
public:

    CHandleBase(CFileTree* lpTree,CSplitterWnd* lpSplitter,void* lpData = NULL);

    void*           lpGetData() { return m_lpData; }
    virtual DWORD   dwGetDataType() = 0;
    CTRFile*        lpGetTRFile() { return m_lpTRFile; }
    virtual void    vSetChanged();
    virtual void    vCopyTo(CHandleBase* lpDst,bool boCopyInSameLevel) { }
    virtual void    vExpandTree(bool boAlreadyExpanded) { }

    virtual CMenu*  lpGetPopupupMenu(HTREEITEM hSelectedItem) { return NULL; }
    virtual void    vReleasePopupupMenu() { }
    virtual void    vHandleMenu(WORD wMenuId) { }

    void    vShowEditDialog(bool boCreatePane,TCHAR* lpszNodeName);
    void    vExpandTree_(HTREEITEM hItem);
    void    vCollapseTree();
    bool    boIsExpanded()  { return m_boExpanded; }

    TCHAR*          lpszGetTitle() { return m_szNodeName; }

protected:

    virtual void    vCreatePane() = 0;
    virtual void    vEditSetInfo(TCHAR* lpszNodeName,bool boForceNew = false) { }
    virtual void    vSetToolboxType();

    CFileTree*      m_lpTree;
    CTRFile*        m_lpTRFile;
    TCHAR           m_szNodeName[256+1];
    CSplitterWnd*   m_lpSplitterWnd;
    void*           m_lpData;
    HTREEITEM       m_hParentItem;
    bool            m_boExpanded;
};