#pragma once

#include "HandleBase.h"

class CHandleMesh : public CHandleBase
{
public:

    CHandleMesh(CFileTree* lpTree,CSplitterWnd* lpSplitter,void* lpData,bool boStaticMesh = false,DWORD dwNumMesh = 0) : CHandleBase(lpTree,lpSplitter,lpData), m_dwNumMesh(dwNumMesh), m_boStaticMesh(boStaticMesh) { }
    DWORD           dwGetDataType() { return 5; }
    CTrLstMsh*      GetMesh(DWORD& dwNumMesh) { dwNumMesh = m_dwNumMesh; return static_cast<CTrLstMsh*>(lpGetData()); }
    bool            boIsStaticMesh() { return m_boStaticMesh; }
    virtual void    vSetChanged(bool boReloadTextures = false);

    virtual CMenu*  lpGetPopupupMenu(HTREEITEM hSelectedItem);
    virtual void    vReleasePopupupMenu();
    virtual void    vHandleMenu(WORD wMenuId);

protected:

    virtual void vCreatePane();
    virtual void vEditSetInfo(TCHAR* lpszNodeName,bool boForceNew = false);
    virtual void vSetToolboxType();

    void         vClearMesh();
    void         vImportFrom3DS();
    void         vExportTo3DS();
    void         vExportAsMSH();
    void         vImportFromMSH(CTrLstMsh* lpMsh = NULL);
    void         vExportTextureToTGA();
    void         vImportTextureFromTGA();
    void         vDelete();

private:

    CMenu*      m_lpMenu;
    bool        m_boStaticMesh;
    DWORD       m_dwNumMesh;

    friend class CHandleRootTR123;
};