// Import3DS.cpp : implementation file
//

#include "stdafx.h"
#include "trviewer.h"
#include "AnimData.h"
#include "AnimKey.h"
#include "AnimTrack.h"
#include "AnimMgr.h"
#include "TRAnimTrack.h"
#include "Import3DS.h"

#ifdef _DEBUG
//!#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CImport3DS dialog


CImport3DS::CImport3DS(CAnimMgr* lpAnimMgr, DWORD dwSelectTrack, CWnd* pParent /*=NULL*/)
	: CDialog(CImport3DS::IDD, pParent)
{
	//{{AFX_DATA_INIT(CImport3DS)
	m_boImportAnim = FALSE;
	m_boImportMeshes = TRUE;
	m_boReplaceAnim = FALSE;
    m_boDeleteAnims = FALSE;
    m_boAddAnim = TRUE;
	//}}AFX_DATA_INIT
    m_lpAnimMgr     = lpAnimMgr;
    m_dwSelectTrack = dwSelectTrack;
}


void CImport3DS::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CImport3DS)
	DDX_Control(pDX, IDC_IMPORT_NUMANIM, m_ListAnims);
	DDX_Check(pDX, IDC_IMPORT_ANIM, m_boImportAnim);
	DDX_Check(pDX, IDC_IMPORT_MESHES, m_boImportMeshes);
	DDX_Check(pDX, IDC_IMPORT_REPLACEANIM, m_boReplaceAnim);
	DDX_Check(pDX, IDC_IMPORT_DELETEANIMS, m_boDeleteAnims);
	DDX_Check(pDX, IDC_IMPORT_ADDANIM, m_boAddAnim);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CImport3DS, CDialog)
	//{{AFX_MSG_MAP(CImport3DS)
	ON_BN_CLICKED(IDC_IMPORT_ANIM, OnImportAnim)
	ON_BN_CLICKED(IDC_IMPORT_MESHES, OnImportMeshes)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CImport3DS message handlers

void CImport3DS::vEnableCtrl()
{
    UpdateData( TRUE );
    
    if( m_boImportAnim )
        {
        m_ListAnims.EnableWindow( TRUE );
        GetDlgItem( IDC_IMPORT_REPLACEANIM )->EnableWindow( TRUE );
        GetDlgItem( IDC_IMPORT_DELETEANIMS )->EnableWindow( TRUE );
        GetDlgItem( IDC_IMPORT_ADDANIM )->EnableWindow( TRUE );
        }
    else
        {
        m_ListAnims.EnableWindow( FALSE );
        GetDlgItem( IDC_IMPORT_REPLACEANIM )->EnableWindow( FALSE );
        GetDlgItem( IDC_IMPORT_DELETEANIMS )->EnableWindow( FALSE );
        GetDlgItem( IDC_IMPORT_ADDANIM )->EnableWindow( FALSE );
        }	
}


void CImport3DS::OnImportAnim() 
{
    vEnableCtrl();
}


void CImport3DS::OnImportMeshes() 
{
    vEnableCtrl();
}


void    CImport3DS::OnOK()
{
    UpdateData( TRUE );

    m_dwSelectTrack = -1;

    if( m_boImportAnim  &&  m_boReplaceAnim ) m_dwSelectTrack = m_ListAnims.GetItemData( m_ListAnims.GetCurSel() );

    CDialog::OnOK();
}


BOOL CImport3DS::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
    GetDlgItem( IDC_IMPORT_REPLACEANIM )->EnableWindow( FALSE );
    GetDlgItem( IDC_IMPORT_DELETEANIMS )->EnableWindow( FALSE );
    GetDlgItem( IDC_IMPORT_ADDANIM )->EnableWindow( FALSE );

    m_ListAnims.EnableWindow( FALSE );
    m_ListAnims.ResetContent();

    // Build the anim list (combo)
    DWORD       dwNumAnims = m_lpAnimMgr->dwGetNumTracks();
    DWORD       dwNumAnim = 0;

    if( m_dwSelectTrack >= dwNumAnims ) m_dwSelectTrack = dwNumAnims - 1;

    while(dwNumAnims--)
        {
        CString s;

        s.Format(_T("Animation #%.3d"),dwNumAnim + 1);

        int iIndex = m_ListAnims.AddString(s);

        m_ListAnims.SetItemData(iIndex, dwNumAnim);

        dwNumAnim++;
        }

    m_ListAnims.SetCurSel( m_dwSelectTrack );

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
