class CResObject
{
public:

    CResObject(enumTrObjType ObjType, DWORD dwObjId) : m_ObjType(ObjType), m_dwObjId(dwObjId) { }
    const enumTrObjType GetObjType() const { return m_ObjType; }
    const DWORD         dwGetObjId() const { return m_dwObjId; }

private:

    enumTrObjType   m_ObjType;
    DWORD           m_dwObjId;
};


typedef std::vector<CResObject> ListResObject;


class CResItem
{
public:

    CResItem(TCHAR* lpszName, TCHAR* lpszLevelName);
    void    vAddObject(enumTrObjType ObjType, DWORD dwObjId);

    const DWORD dwGetNumObjects() const { return m_ListObjects.size(); }
    const CResObject& GetResObject(DWORD dwNum) const { return m_ListObjects[dwNum]; }
    const TCHAR* lpszGetLevelName() const { return m_szLevelName; }

private:

    TCHAR           m_szName[128 + 1];
    TCHAR           m_szLevelName[128 + 1];
    ListResObject   m_ListObjects;
};


class CResSFX
{
public:

    CResSFX(TCHAR* lpszName, DWORD dwNumSamples, DWORD dwFirstSoundIndex) : m_cstrName(lpszName), m_dwNumSamples(dwNumSamples), m_dwFirstSoundIndex(dwFirstSoundIndex) { }

    CString     m_cstrName;
    DWORD       m_dwNumSamples;
    DWORD       m_dwFirstSoundIndex;
};


typedef std::vector<CResItem*>  ListResItem;
typedef std::vector<CResSFX*>   ListSfx;


#define     __RESMGR_TR1__          0
#define     __RESMGR_TR1GOLD__      1
#define     __RESMGR_TR2__          2
#define     __RESMGR_TR2GOLD__      3
#define     __RESMGR_TR3__          4
#define     __RESMGR_TR3GOLD__      5

#define     __RESMGR_MAXTR__        6

class CResMgr
{
public:

    CResMgr();
    ~CResMgr();
    void            vInitialize(TCHAR* lpszPath);
    void            vRelease();

    const CMenu*    lpGetMenu(BYTE bTRResId) const                      { return &m_Menu[bTRResId]; }
    const CResItem* lpGetResItem(BYTE bTRResId, DWORD dwNum) const      { return m_List[bTRResId][dwNum]; }

    const CString&  cstrGetDataPath(BYTE bTRResId) const                { return m_DataPath[bTRResId]; }
    void            vSetDataPath(BYTE bTRResId, CString& cstrDataPath);

    CString         cstrGetSfxName(BYTE bTRResId, DWORD dwInternalIndex) const;
    DWORD           dwGetSfxNumSamples(BYTE bTRResId, DWORD dwInternalIndex) const;
    DWORD           dwGetSfxFirstSoundIndex(BYTE bTRResId, DWORD dwInternalIndex) const;

    BYTE            bGetResId(enumTRType trType) const;

private:

    void    vParseFile_MenuResource(CMenu& Menu, TCHAR* lpszFilename, enumTRType trType, ListResItem& List);
    void    vParseFile_SFX(CString& cstrFilename, ListSfx& ListSFX);

    ListResItem             m_List[__RESMGR_MAXTR__];
    CMenu                   m_Menu[__RESMGR_MAXTR__];

    ListSfx                 m_ListSFX[__RESMGR_MAXTR__];

    CString                 m_DataPath[__RESMGR_MAXTR__];

    TCHAR                   m_szPath[MAX_PATH + 1];
};

