// TRViewer.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "TRViewer.h"

#include "MainFrm.h"
#include "ChildFrm.h"
#include "TRViewerDoc.h"
#include "TRViewerView.h"
#include "EditMesh.h"
#include "EditMoveable.h"
#include "EditSprite.h"

#ifdef _DEBUG
//!#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern bool g_boSavingLevel;


BOOL    boRegisterCOMDll(TCHAR* lpszAppPath)
{
    BOOL boOk = FALSE;

    HRESULT (FAR STDAPICALLTYPE * lpDllEntryPoint)(void);
    HINSTANCE hLib = LoadLibrary(lpszAppPath);

    if (hLib < (HINSTANCE)HINSTANCE_ERROR) return FALSE;

    // Find the entry point.
    (FARPROC&)lpDllEntryPoint = GetProcAddress(hLib, "DllRegisterServer");
    if (lpDllEntryPoint != NULL)
      {
      if(FAILED((*lpDllEntryPoint)())) ; else boOk = TRUE;
      }

    FreeLibrary(hLib);

    return boOk;
}


/////////////////////////////////////////////////////////////////////////////
// CTRViewerApp

BEGIN_MESSAGE_MAP(CTRViewerApp, CWinApp)
	//{{AFX_MSG_MAP(CTRViewerApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
	//ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTRViewerApp construction

CTRViewerApp::CTRViewerApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CTRViewerApp object

CTRViewerApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CTRViewerApp initialization

BOOL CTRViewerApp::InitInstance()
{
    // Register the ReadPic COM component (should be in the same directory
    // than TRViewer.exe)
    TCHAR szFileName[MAX_PATH];
    GetModuleFileName(NULL,szFileName,MAX_PATH);

    TCHAR   szDrive[_MAX_DRIVE];
    TCHAR   szDir[_MAX_DIR];
    TCHAR   szReadPicPath[MAX_PATH];

    _tsplitpath(szFileName,szDrive,szDir,NULL,NULL);

    lstrcpy(szReadPicPath,szDrive);
    lstrcat(szReadPicPath,szDir);

    CString cstrPath(szReadPicPath);

    cstrPath += _T("ReadPic.dll");

    boRegisterCOMDll((LPTSTR)(LPCTSTR)cstrPath);

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	if (!AfxOleInit()) AfxMessageBox("Error calling AfxOleInit !");

	// Change the registry key under which our settings are stored.
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("Popov Inc."));

	LoadStdProfileSettings(10);  // Load standard INI file options (including MRU)

    //
    cstrPath = szReadPicPath;
    cstrPath += _T("Resources\\");

    CString cstr1 = GetProfileString(_T("Settings"),_T("TR1 Data Path"),_T("\\"));
    m_ResMgr.vSetDataPath(__RESMGR_TR1__, cstr1);

    CString cstr1g = GetProfileString(_T("Settings"),_T("TR1Gold Data Path"),_T("\\"));
    m_ResMgr.vSetDataPath(__RESMGR_TR1GOLD__, cstr1g);

    CString cstr2 = GetProfileString(_T("Settings"),_T("TR2 Data Path"),_T("\\"));
    m_ResMgr.vSetDataPath(__RESMGR_TR2__, cstr2);

    CString cstr2g = GetProfileString(_T("Settings"),_T("TR2Gold Data Path"),_T("\\"));
    m_ResMgr.vSetDataPath(__RESMGR_TR2GOLD__, cstr2g);

    CString cstr3 = GetProfileString(_T("Settings"),_T("TR3 Data Path"),_T("\\"));
    m_ResMgr.vSetDataPath(__RESMGR_TR3__, cstr3);

    CString cstr3g = GetProfileString(_T("Settings"),_T("TR3Gold Data Path"),_T("\\"));
    m_ResMgr.vSetDataPath(__RESMGR_TR3GOLD__, cstr3g);

    m_ResMgr.vInitialize((LPTSTR)(LPCTSTR)cstrPath);
    //

	AfxEnableControlContainer();

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMultiDocTemplate(
		IDR_TRVIEWTYPE,
		RUNTIME_CLASS(CTRViewerDoc),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CTRViewerView));
	AddDocTemplate(pDocTemplate);

	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;

	// Enable drag/drop open
	m_pMainWnd->DragAcceptFiles();

	// Enable DDE Execute open
	EnableShellOpen();
	RegisterShellFileTypes(TRUE);

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

    if(!m_lpCmdLine || (m_lpCmdLine && !m_lpCmdLine[0])) cmdInfo.m_nShellCommand = CCommandLineInfo::FileNothing;

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The main window has been initialized, so show and update it.
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();

	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CTRViewerApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CTRViewerApp message handlers


BOOL CTRViewerApp::OnIdle(LONG lCount) 
{
    BOOL boMore = CWinApp::OnIdle(lCount);

    CView*  lpView = CTRViewerView::GetActiveView();

    if(lpView  &&  !g_boSavingLevel)
        {
        if(lpView->IsKindOf(RUNTIME_CLASS(CTRViewerView))) boMore = ((CTRViewerView*)lpView)->boOnIdle();
        else if(lpView->IsKindOf(RUNTIME_CLASS(CEditMesh))) boMore = ((CEditMesh*)lpView)->boOnIdle();
        else if(lpView->IsKindOf(RUNTIME_CLASS(CEditMoveable))) boMore = ((CEditMoveable*)lpView)->boOnIdle();
        else if(lpView->IsKindOf(RUNTIME_CLASS(CEditSprite))) boMore = ((CEditSprite*)lpView)->boOnIdle();
        }

	return boMore;
}
