#if !defined(AFX_TOOLBOXMESH_H__CD888DA5_1E91_11D4_AA77_00105A49000B__INCLUDED_)
#define AFX_TOOLBOXMESH_H__CD888DA5_1E91_11D4_AA77_00105A49000B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ToolboxMesh.h : header file
//

#include "Toolbox.h"

class CHandleMesh;
class CEditMesh;

/////////////////////////////////////////////////////////////////////////////
// CToolboxMesh dialog

class CToolboxMesh : public CToolbox
{
// Construction
public:

	CToolboxMesh(CWnd* pParent = NULL);   // standard constructor

    void    vSetDataTypeHandler(CHandleMesh* lpHandler,CEditMesh* lpEdit);
    BOOL    boStaticBB1IsSel() { return m_boBB1On; }
    BOOL    boStaticBB2IsSel() { return m_boBB2On; }

// Dialog Data
	//{{AFX_DATA(CToolboxMesh)
	enum { IDD = IDD_TOOLBOX_MESH };
	CSliderCtrl	m_IntensitySlider;
	long	m_lCollSphereRadius;
	CString	m_cstrNumQuads;
	CString	m_cstrNumTris;
	CString	m_cstrNumVert;
	long	m_lBB1x;
	long	m_lBB1y;
	long	m_lBB1z;
	long	m_lBB2x;
	long	m_lBB2y;
	long	m_lBB2z;
	CString	m_cstrExtents;
	BOOL	m_boBB1On;
	BOOL	m_boBB2On;
	BOOL	m_boFlagCollide;
	BOOL	m_boFlagVisible;
	CString	m_cstrObjId;
	BOOL	m_boDummyMesh;
	BOOL	m_boIntensityAlpha;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CToolboxMesh)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CToolboxMesh)
	afx_msg void OnClose();
	afx_msg void OnCollSphereShow();
	afx_msg void OnKillfocusCollsphereradius();
	afx_msg void OnDeltaposSpinsphradius(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnVerticesshow();
	afx_msg void OnMeshlighting();
	afx_msg void OnKillfocusBb1x();
	afx_msg void OnKillfocusBb1y();
	afx_msg void OnKillfocusBb1z();
	afx_msg void OnKillfocusBb2x();
	afx_msg void OnKillfocusBb2y();
	afx_msg void OnKillfocusBb2z();
	afx_msg void OnMeshbb1on();
	afx_msg void OnMeshbb1show();
	afx_msg void OnMeshbb2on();
	afx_msg void OnMeshbb2show();
	afx_msg void OnMeshflagCollide();
	afx_msg void OnMeshflagVisible();
	afx_msg void OnKillfocusMeshObjid();
	afx_msg void OnMeshDummy();
	afx_msg void OnMeshIntensityAlpha();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:

    CHandleMesh*        m_lpDataHandler;
    CEditMesh*          m_lpDataEdit;
    bool                m_boCollSphereShow;
    bool                m_boShowVertices;
    bool                m_boShowStaticBB1;
    bool                m_boShowStaticBB2;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TOOLBOXMESH_H__CD888DA5_1E91_11D4_AA77_00105A49000B__INCLUDED_)
