// ToolboxMoveable.cpp : implementation file
//

#include "stdafx.h"
#include "trviewer.h"
#include "EditMoveable.h"
#include "HandleMoveable.h"
#include "ToolboxMoveable.h"

#include "AnimData.h"
#include "AnimKey.h"
#include "AnimTrack.h"
#include "AnimMgr.h"
#include "TRAnimTrack.h"

/////////////////////////////////////////////////////////////////////////////
// CToolboxMoveable dialog


CToolboxMoveable::CToolboxMoveable(CWnd* pParent /*=NULL*/)
	
{
    CDialog(CToolboxMoveable::IDD, pParent);

	//{{AFX_DATA_INIT(CToolboxMoveable)
	m_cstrObjId = _T("");
	m_cstrMvblExtents = _T("");
	m_cstrCurAnim = _T("");
	m_cstrCurFrame = _T("");
	m_dwAnimFrameRate = 0;
	m_cstrNumTotFrames = _T("");
	m_cstrCurKey = _T("");
	m_cstrNumTotKeys = _T("");
    m_dwAnimSpeed       = 50;
	m_fAnimInterp = 0.0f;
	m_cstrStateId = _T("");
    m_cstrAnmUnk    = _T("");
    m_cstrAnmSpeed  = _T("");
    m_cstrAnmAccel  = _T("");
	m_lAnmCmdP[0] = 0;
	m_lAnmCmdP[1] = 0;
	m_lAnmCmdP[2] = 0;
	m_lAnmCmdP[3] = 0;
	m_dwNextAnim = 0;
	m_dwNextFrame = 0;
	m_lAnmDispP[0] = 0;
	m_lAnmDispP[1] = 0;
	m_lAnmDispP[2] = 0;
	m_lAnmDispP[3] = 0;
	m_lAnmDispP[4] = 0;
	//}}AFX_DATA_INIT
    m_lpDataHandler     = NULL;
    m_lpDataEdit        = NULL;
    m_boChainAnimations = false;
    m_boAutomaticAnim   = true;
    m_boAnimInterp      = true;
    m_boAnmParamsInHexa = false;
    m_lAnmUnk           = 0;
    m_lAnmSpeed         = 0;
    m_fAnmAccel         = 0.0f;
    m_hBitmapNew        = 0;
    m_hBitmapDel        = 0;
    m_hBitmapUp         = 0;
    m_hBitmapDown       = 0;
}


CToolboxMoveable::~CToolboxMoveable()
{
    if(m_hBitmapNew)        DeleteObject(m_hBitmapNew);
    if(m_hBitmapDel)        DeleteObject(m_hBitmapDel);
    if(m_hBitmapUp)         DeleteObject(m_hBitmapUp);
    if(m_hBitmapDown)       DeleteObject(m_hBitmapDown);
    if(m_hBitmapValidate)   DeleteObject(m_hBitmapValidate);
}


void CToolboxMoveable::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CToolboxMoveable)
	DDX_Control(pDX, IDC_ANIMDISPATCH, m_AnimDispatch);
	DDX_Control(pDX, IDC_SLIDERSPEED, m_SliderSpeed);
	DDX_Control(pDX, IDC_SPININTERP, m_SpinInterp);
	DDX_Control(pDX, IDC_SLIDERKEY, m_SliderKey);
	DDX_Control(pDX, IDC_SLIDERFRAME, m_SliderFrame);
	DDX_Control(pDX, IDC_COMBOANIM, m_LstAnims);
	DDX_Text(pDX, IDC_OBJID, m_cstrObjId);
	DDX_Text(pDX, IDC_MVBLEXTENTS, m_cstrMvblExtents);
	DDX_Text(pDX, IDC_CURANIM, m_cstrCurAnim);
	DDX_Text(pDX, IDC_CURFRAME, m_cstrCurFrame);
	DDX_Text(pDX, IDC_ANIMSPEED, m_dwAnimFrameRate);
	DDX_Text(pDX, IDC_NUMTOTFRAMES, m_cstrNumTotFrames);
	DDX_Text(pDX, IDC_CURKEY, m_cstrCurKey);
	DDX_Text(pDX, IDC_NUMTOTKEYS, m_cstrNumTotKeys);
	DDX_Text(pDX, IDC_ANIMOVERALLSPEED, m_dwAnimSpeed);
	DDX_Text(pDX, IDC_INTERP, m_fAnimInterp);
	DDX_Text(pDX, IDC_MVBSTATEID, m_cstrStateId);
	DDX_Text(pDX, IDC_ANM_PARAM1, m_cstrAnmUnk);
	DDX_Text(pDX, IDC_ANM_PARAM2, m_cstrAnmSpeed);
	DDX_Text(pDX, IDC_ANM_PARAM3, m_cstrAnmAccel);
	DDX_Control(pDX, IDC_ANIMCOMMANDS, m_AnimCommands);
	DDX_Text(pDX, IDC_ANMCMD_P1, m_lAnmCmdP[0]);
	DDX_Text(pDX, IDC_ANMCMD_P2, m_lAnmCmdP[1]);
	DDX_Text(pDX, IDC_ANMCMD_P3, m_lAnmCmdP[2]);
	DDX_Text(pDX, IDC_ANMCMD_P4, m_lAnmCmdP[3]);
	DDX_Text(pDX, IDC_MVBNEXTANIM, m_dwNextAnim);
	DDX_Text(pDX, IDC_MVBNEXTFRAME, m_dwNextFrame);
	DDX_Text(pDX, IDC_ANMDISP_P0, m_lAnmDispP[0]);
	DDX_Text(pDX, IDC_ANMDISP_P1, m_lAnmDispP[1]);
	DDX_Text(pDX, IDC_ANMDISP_P2, m_lAnmDispP[2]);
	DDX_Text(pDX, IDC_ANMDISP_P3, m_lAnmDispP[3]);
	DDX_Text(pDX, IDC_ANMDISP_P4, m_lAnmDispP[4]);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CToolboxMoveable, CDialog)
	//{{AFX_MSG_MAP(CToolboxMoveable)
	ON_WM_CLOSE()
	ON_CBN_SELCHANGE(IDC_COMBOANIM, OnSelchangeComboanim)
	ON_BN_CLICKED(IDC_TYPEANIM, OnTypeanim)
	ON_BN_CLICKED(IDC_ANIMMODE, OnAnimmode)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_INTERPON, OnInterpon)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPININTERP, OnDeltaposSpininterp)
	ON_EN_KILLFOCUS(IDC_INTERP, OnKillfocusInterp)
	ON_EN_KILLFOCUS(IDC_OBJID, OnKillfocusObjId)
	ON_BN_CLICKED(IDC_HEXDEC, OnHexdec)
	ON_EN_KILLFOCUS(IDC_ANM_PARAM1, OnKillfocusAnmParam1)
	ON_EN_KILLFOCUS(IDC_ANM_PARAM2, OnKillfocusAnmParam2)
	ON_EN_KILLFOCUS(IDC_ANM_PARAM3, OnKillfocusAnmParam3)
	ON_BN_CLICKED(IDC_ANMCMD_SET, OnAnmcmdSet)
	ON_NOTIFY(NM_CLICK, IDC_ANIMCOMMANDS, OnClickAnimcommands)
	ON_EN_KILLFOCUS(IDC_MVBNEXTANIM, OnKillfocusNextAnim)
	ON_EN_KILLFOCUS(IDC_MVBNEXTFRAME, OnKillfocusNextFrame)
	ON_BN_CLICKED(IDC_ANMDISP_SET, OnAnmdispSet)
	ON_NOTIFY(NM_CLICK, IDC_ANIMDISPATCH, OnClickAnimdispatch)
	ON_EN_KILLFOCUS(IDC_MVBSTATEID, OnKillfocusStateId)
	ON_BN_CLICKED(IDC_ANMCMD_ADD, OnAnmCmdNew)
	ON_BN_CLICKED(IDC_ANMCMD_DEL, OnAnmCmdDel)
	ON_BN_CLICKED(IDC_ANMCMD_UP, OnAnmCmdUp)
	ON_BN_CLICKED(IDC_ANMCMD_DOWN, OnAnmCmdDown)
	ON_BN_CLICKED(IDC_ANMDISP_DEL, OnAnmDispDel)
	ON_BN_CLICKED(IDC_ANMDISP_ADD, OnAnmDispNew)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CToolboxMoveable message handlers

BOOL CToolboxMoveable::OnInitDialog() 
{
	CDialog::OnInitDialog();

    // Load the bitmaps
    m_hBitmapNew        = LoadBitmap((HINSTANCE)GetModuleHandle(NULL),MAKEINTRESOURCE(IDB_NEW));
    ::SendDlgItemMessage(m_hWnd,IDC_ANMCMD_ADD,BM_SETIMAGE,IMAGE_BITMAP,(LPARAM)m_hBitmapNew);
    m_hBitmapDel        = LoadBitmap((HINSTANCE)GetModuleHandle(NULL),MAKEINTRESOURCE(IDB_DEL));
    ::SendDlgItemMessage(m_hWnd,IDC_ANMCMD_DEL,BM_SETIMAGE,IMAGE_BITMAP,(LPARAM)m_hBitmapDel);
    m_hBitmapUp         = LoadBitmap((HINSTANCE)GetModuleHandle(NULL),MAKEINTRESOURCE(IDB_UP));
    ::SendDlgItemMessage(m_hWnd,IDC_ANMCMD_UP,BM_SETIMAGE,IMAGE_BITMAP,(LPARAM)m_hBitmapUp);
    m_hBitmapDown       = LoadBitmap((HINSTANCE)GetModuleHandle(NULL),MAKEINTRESOURCE(IDB_DOWN));
    ::SendDlgItemMessage(m_hWnd,IDC_ANMCMD_DOWN,BM_SETIMAGE,IMAGE_BITMAP,(LPARAM)m_hBitmapDown);
    m_hBitmapValidate   = LoadBitmap((HINSTANCE)GetModuleHandle(NULL),MAKEINTRESOURCE(IDB_VALIDATE));
    ::SendDlgItemMessage(m_hWnd,IDC_ANMCMD_SET,BM_SETIMAGE,IMAGE_BITMAP,(LPARAM)m_hBitmapValidate);

    ::SendDlgItemMessage(m_hWnd,IDC_ANMDISP_ADD,BM_SETIMAGE,IMAGE_BITMAP,(LPARAM)m_hBitmapNew);
    ::SendDlgItemMessage(m_hWnd,IDC_ANMDISP_DEL,BM_SETIMAGE,IMAGE_BITMAP,(LPARAM)m_hBitmapDel);
    ::SendDlgItemMessage(m_hWnd,IDC_ANMDISP_SET,BM_SETIMAGE,IMAGE_BITMAP,(LPARAM)m_hBitmapValidate);

    // Build the state change / anim dispatch list view
    LVCOLUMN gcoll1 = {LVCF_WIDTH | LVCF_TEXT,LVCFMT_CENTER,38,__TEXT("State"),0,0};
    ListView_InsertColumn(::GetDlgItem(m_hWnd,IDC_ANIMDISPATCH),0,&gcoll1);

    LVCOLUMN gcoll2 = {LVCF_WIDTH | LVCF_TEXT,LVCFMT_CENTER,50,__TEXT("Low frm"),0,0};
    ListView_InsertColumn(::GetDlgItem(m_hWnd,IDC_ANIMDISPATCH),1,&gcoll2);

    LVCOLUMN gcoll3 = {LVCF_WIDTH | LVCF_TEXT,LVCFMT_CENTER,54,__TEXT("High frm"),0,0};
    ListView_InsertColumn(::GetDlgItem(m_hWnd,IDC_ANIMDISPATCH),2,&gcoll3);

    LVCOLUMN gcoll4 = {LVCF_WIDTH | LVCF_TEXT,LVCFMT_CENTER,58,__TEXT("Next anm"),0,0};
    ListView_InsertColumn(::GetDlgItem(m_hWnd,IDC_ANIMDISPATCH),3,&gcoll4);

    LVCOLUMN gcoll5 = {LVCF_WIDTH | LVCF_TEXT,LVCFMT_CENTER,54,__TEXT("Next frm"),0,0};
    ListView_InsertColumn(::GetDlgItem(m_hWnd,IDC_ANIMDISPATCH),4,&gcoll5);

    m_AnimDispatch.DeleteAllItems();
    
    DWORD dwStyle1 = ListView_GetExtendedListViewStyle(m_AnimDispatch.m_hWnd);

    dwStyle1 |= LVS_EX_FULLROWSELECT;
    ListView_SetExtendedListViewStyle(m_AnimDispatch.m_hWnd, dwStyle1);


    // Build the anim command list view    
    LVCOLUMN hcoll1 = {LVCF_WIDTH | LVCF_TEXT,LVCFMT_CENTER,47,__TEXT("Cmd"),0,0};
    ListView_InsertColumn(::GetDlgItem(m_hWnd,IDC_ANIMCOMMANDS),0,&hcoll1);

    LVCOLUMN hcoll2 = {LVCF_WIDTH | LVCF_TEXT,LVCFMT_CENTER,69,__TEXT("Param 1"),0,0};
    ListView_InsertColumn(::GetDlgItem(m_hWnd,IDC_ANIMCOMMANDS),1,&hcoll2);

    LVCOLUMN hcoll3 = {LVCF_WIDTH | LVCF_TEXT,LVCFMT_CENTER,69,__TEXT("Param 2"),0,0};
    ListView_InsertColumn(::GetDlgItem(m_hWnd,IDC_ANIMCOMMANDS),2,&hcoll3);

    LVCOLUMN hcoll4 = {LVCF_WIDTH | LVCF_TEXT,LVCFMT_CENTER,69,__TEXT("Param 3"),0,0};
    ListView_InsertColumn(::GetDlgItem(m_hWnd,IDC_ANIMCOMMANDS),3,&hcoll4);

    m_AnimCommands.DeleteAllItems();

    DWORD dwStyle2 = ListView_GetExtendedListViewStyle(m_AnimCommands.m_hWnd);

    dwStyle2 |= LVS_EX_FULLROWSELECT;
    ListView_SetExtendedListViewStyle(m_AnimCommands.m_hWnd, dwStyle2);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void CToolboxMoveable::OnClose() 
{
    vOnClose();
}


// Display the bounding box extents of the moveable
void CToolboxMoveable::vRefreshExtents(bool boUpdateData)
{
    CTrMvb* lpMoveable = m_lpDataHandler ? m_lpDataHandler->GetMoveable() : NULL;

    CString s(_T(""));

    if(lpMoveable)
        {
        CBoundingBox BoundingBox;

        lpMoveable->vComputeBoundingBox(BoundingBox);

        CVect3D vec = BoundingBox.GetBBHi() - BoundingBox.GetBBLo();

        s.Format(_T("%ld,%ld,%ld"),(long)vec[0],(long)vec[1],(long)vec[2]);
        }

    m_cstrMvblExtents = s;

    if(boUpdateData) UpdateData(FALSE);
}


// Set the moveable infos in the toolbox pane
void CToolboxMoveable::vSetDataTypeHandler(CHandleMoveable* lpHandler,CEditMoveable* lpEdit,bool boForceNewMoveable /*= false*/)
{
    CString s(_T(""));
    bool    boNewMoveable = true;
    CTrMvb* lpMoveable = lpHandler ? lpHandler->GetMoveable() : NULL;
    DWORD   dwNumTris = 0, dwNumQuads = 0;

    // If there is already a moveable in the toolbox, check
    // to see if it's the same as the new moveable
    if(m_lpDataHandler  &&  !boForceNewMoveable)
        {
        CTrMvb* lpOldMoveable = m_lpDataHandler->GetMoveable();
        boNewMoveable = (lpMoveable != lpOldMoveable);
        }

    m_lpDataHandler = lpHandler;
    m_lpDataEdit    = lpEdit;

    // The new moveable exists ?
    if(lpMoveable)
        {
        // Yes, set some general infos about the moveable in the toolbox
        for(DWORD dwI = 0; dwI < lpMoveable->dwGetNumMeshes(); dwI++)
            {
            const TR123_MESH* lpMesh = lpMoveable->lpGetMesh(dwI);

            if(lpMesh)
                {
                dwNumTris   += lpMesh->sNumColoredTriangles + lpMesh->sNumTexturedTriangles;
                dwNumQuads  += lpMesh->sNumColoredRectangles + lpMesh->sNumTexturedRectangles;
                }
            }

        // Num meshes
        s.Format("%ld (%ld tris, %ld quads)",lpMoveable->dwGetNumMeshes(),dwNumTris,dwNumQuads);
        GetDlgItem(IDC_NUMMESHES)->SetWindowText(s);

        // Object Id
        s.Format(_T("%ld"),lpMoveable->dwGetObjectId());
        m_cstrObjId = s;
        }
    else
        {
        // No, reset infos
        GetDlgItem(IDC_NUMMESHES)->SetWindowText(s);
        m_cstrObjId = s;
        }

    vRefreshExtents(false);

    if(m_lpDataEdit)
        {
        CRect Rect;

        m_lpDataEdit->vSetAutomaticAnim(m_boAutomaticAnim);
        m_lpDataEdit->vSetAnimInterp(m_boAnimInterp);
        m_lpDataEdit->vSetAnimationType(m_boChainAnimations,false);

        m_lpDataEdit->GetClientRect(&Rect);
        m_lpDataEdit->OnSize(0,Rect.right,Rect.bottom);
        }

    // Set the global parameters of the moveable toolbox
    ((CButton*)GetDlgItem(IDC_ANIMMODE))->SetWindowText(m_boAutomaticAnim ? _T("Automatic") : _T("Manual"));
    ((CButton*)GetDlgItem(IDC_INTERPON))->SetWindowText(m_boAnimInterp ? _T("on") : _T("off"));
    GetDlgItem(IDC_MOVEABLENAME)->SetWindowText(lpHandler ? lpHandler->lpszGetTitle() : _T(""));
    ((CButton*)GetDlgItem(IDC_HEXDEC))->SetWindowText(m_boAnmParamsInHexa ? _T("Hex") : _T("Dec"));
    ((CButton*)GetDlgItem(IDC_TYPEANIM))->SetWindowText(m_boChainAnimations ? _T("Chain") : _T("Loop"));

    // Set the anim controls / parameters
    m_SliderSpeed.SetRange(1,100);

    if(boNewMoveable)
        {
        // Set the parameters only if it's a new moveable. If it is not,
        // the parameters have been already set previously
        m_LstAnims.ResetContent();

        int iIndex = m_LstAnims.AddString(_T("No animation"));
        m_LstAnims.SetItemData(iIndex,-1);

        if(lpMoveable)
            {
            // Build the anim list (combo)
            CAnimMgr*   lpAnimMgr = lpMoveable->lpGetAnimMgr();
            DWORD       dwNumAnims = lpAnimMgr->dwGetNumTracks();
            DWORD       dwNumAnim = 0;

            while(dwNumAnims--)
                {
                s.Format(_T("Animation #%.3d"),dwNumAnim + 1);

                iIndex = m_LstAnims.AddString(s);

                m_LstAnims.SetItemData(iIndex, dwNumAnim);

                dwNumAnim++;
                }
            }

        // Initialize anim parameters
        m_cstrCurAnim       = _T("");
        m_cstrCurFrame      = _T("");
        m_cstrNumTotFrames  = _T("");
        m_cstrCurKey        = _T("");
        m_cstrNumTotKeys    = _T("");
        m_cstrStateId       = _T("");
        m_dwAnimFrameRate   = 0;
        m_dwAnimSpeed       = 50;
        m_fAnimInterp       = 0.0f;
        m_cstrAnmUnk        = _T("");
        m_cstrAnmSpeed      = _T("");
        m_cstrAnmAccel      = _T("");
        m_dwNextAnim        = 0;
        m_dwNextFrame       = 0;

        if(m_lpDataEdit)
            {
            m_lpDataEdit->vSetAnimInterp(0.0f);
            m_lpDataEdit->vSetAnimOverallSpeed(m_dwAnimSpeed / 100.0f);
            }

        m_LstAnims.SetCurSel(0);
        m_SliderSpeed.SetPos(m_dwAnimSpeed);
        }

    m_AnimDispatch.DeleteAllItems();
    m_AnimCommands.DeleteAllItems();

    m_lAnmDispP[0] = 0;
    m_lAnmDispP[1] = 0;
    m_lAnmDispP[2] = 0;
    m_lAnmDispP[3] = 0;
    m_lAnmDispP[4] = 0;

    m_lAnmCmdP[0] = 0;
    m_lAnmCmdP[1] = 0;
    m_lAnmCmdP[2] = 0;
    m_lAnmCmdP[3] = 0;

    UpdateData(FALSE);
}


void CToolboxMoveable::OnSelchangeComboanim() 
{
    CTrMvb*   lpMoveable = m_lpDataHandler ? m_lpDataHandler->GetMoveable() : NULL;

    int iIndex = m_LstAnims.GetCurSel();

    if(iIndex == -1  ||  !lpMoveable) return;

    m_lpDataEdit->vSetAnimation(m_LstAnims.GetItemData(iIndex));
}

void CToolboxMoveable::OnTypeanim() 
{
	CButton* lpButton = (CButton*)GetDlgItem(IDC_TYPEANIM);

    CString cstrTxt;
    
    lpButton->GetWindowText(cstrTxt);

    if(cstrTxt == _T("Loop"))
        {
        lpButton->SetWindowText(_T("Chain"));
        m_boChainAnimations = true;
        }
    else
        {
        lpButton->SetWindowText(_T("Loop"));
        m_boChainAnimations = false;
        }

    if(m_lpDataEdit) m_lpDataEdit->vSetAnimationType(m_boChainAnimations);

    OnSelchangeComboanim();
}


void CToolboxMoveable::vSetAnimParams()
{
    CString s;

    m_lAnmUnk = (short)m_lAnmUnk;
    if(m_boAnmParamsInHexa) { s.Format(_T("%.4X"),m_lAnmUnk); s = s.Right(4); } else s.Format(_T("%ld"),m_lAnmUnk);
    m_cstrAnmUnk = s;

    m_lAnmSpeed = (short)m_lAnmSpeed;
    s.Format(_T("%ld"),m_lAnmSpeed);
    m_cstrAnmSpeed = s;

    s.Format(_T("%f"),m_fAnmAccel);
    m_cstrAnmAccel = s;
}


void CToolboxMoveable::vSetCurAnim(DWORD dwCurAnim)
{
    DWORD   dwOld = _ttol(m_cstrCurAnim); if(dwOld) dwOld = dwOld - 1;

    if(dwOld == dwCurAnim  &&  m_cstrCurAnim != _T("")) return;

    CString s;

    s.Format(_T("%ld"),dwCurAnim + 1);
    m_cstrCurAnim = s;

    if(!m_lpDataHandler) return;

    m_AnimDispatch.DeleteAllItems();

    CTrMvb*         lpMoveable  = m_lpDataHandler->GetMoveable();
    CAnimMgr*       lpAnimMgr   = lpMoveable->lpGetAnimMgr();
    CTRAnimTrack*   lpTrack     = static_cast<CTRAnimTrack*>(lpAnimMgr->lpGetCurrentTrack());

    lpAnimMgr->vGetNextAnimInfos(m_dwNextAnim,m_dwNextFrame);

    m_dwNextAnim++;
    m_dwNextFrame++;

    s.Format(_T("%ld"),dwCurAnim + 1);
    m_cstrCurAnim = s;

    s.Format(_T("%ld"),lpTrack->dwGetStateId());
    m_cstrStateId = s;

    short sUnknown;

    lpTrack->vGetPlayParams(sUnknown,m_lAnmSpeed,m_fAnmAccel);

    m_lAnmUnk = sUnknown;

    vSetAnimParams();

    DWORD dwDummy;

    vShowAnimDispatch( lpTrack, 0, 0, 0, 0, 0, dwDummy );
    vShowAnimCommands( lpTrack );

    UpdateData(FALSE);
}


void CToolboxMoveable::vSetCurFrame(DWORD dwCurFrame,DWORD dwNumFrames)
{
    CString s;

    s.Format(_T("%ld"),dwCurFrame + 1);
    m_cstrCurFrame = s;

    s.Format(_T("/ %ld"),dwNumFrames);
    m_cstrNumTotFrames = s;

    CWnd* lpWnd = GetDlgItem(IDC_CURFRAME);
    lpWnd->SetWindowText(m_cstrCurFrame);

    lpWnd = GetDlgItem(IDC_NUMTOTFRAMES);
    lpWnd->SetWindowText(m_cstrNumTotFrames);

    m_SliderFrame.SetRange(1,dwNumFrames);
    m_SliderFrame.SetPageSize(1);
    m_SliderFrame.SetPos(dwCurFrame + 1);
}

void CToolboxMoveable::vSetCurKey(DWORD dwCurKey,DWORD dwNumKeys)
{
    CString s;

    s.Format(_T("%ld"),dwCurKey + 1);
    m_cstrCurKey = s;

    s.Format(_T("/ %ld"),dwNumKeys);
    m_cstrNumTotKeys = s;

    CWnd* lpWnd = GetDlgItem(IDC_CURKEY);
    lpWnd->SetWindowText(m_cstrCurKey);

    lpWnd = GetDlgItem(IDC_NUMTOTKEYS);
    lpWnd->SetWindowText(m_cstrNumTotKeys);

    m_SliderKey.SetRange(1,dwNumKeys);
    m_SliderKey.SetPageSize(1);
    m_SliderKey.SetPos(dwCurKey + 1);
}


void CToolboxMoveable::vSetInterp(float fInterp)
{
    CString s;

    s.Format(_T("%f"),fInterp);

    CWnd* lpWnd = GetDlgItem(IDC_INTERP);

    lpWnd->SetWindowText(s);
}


void CToolboxMoveable::vSetAnimationFrameRate(DWORD dwAnimFrameRate)
{
    m_dwAnimFrameRate = dwAnimFrameRate;

    CString s;

    s.Format(_T("%ld"),dwAnimFrameRate);

    CWnd* lpWnd = GetDlgItem(IDC_ANIMSPEED);
    lpWnd->SetWindowText(s);
}


void CToolboxMoveable::OnKillfocusStateId() 
{
    CTrMvb*   lpMoveable = m_lpDataHandler ? m_lpDataHandler->GetMoveable() : NULL;

    if(!lpMoveable) return;

    CAnimMgr*       lpAnimMgr = lpMoveable->lpGetAnimMgr();
    DWORD           dwCurAnim = _ttol(m_cstrCurAnim); if(dwCurAnim) dwCurAnim--;
    CTRAnimTrack*   lpTrack = static_cast<CTRAnimTrack*>(lpAnimMgr->lpGetCurrentTrack());

	UpdateData(TRUE);

    lpTrack->vSetStateId( _ttol( m_cstrStateId ) );

    CString s;

    s.Format(_T("%ld"),lpTrack->dwGetStateId());
    m_cstrStateId = s;

    UpdateData( FALSE );
}


void CToolboxMoveable::vSetAnimationNextAnim(DWORD dwNextAnim,DWORD dwNextFrame)
{
    m_dwNextAnim    = dwNextAnim + 1;
    m_dwNextFrame   = dwNextFrame + 1;

    UpdateData(FALSE);
}


void CToolboxMoveable::OnAnimmode() 
{
	CButton* lpButton = (CButton*)GetDlgItem(IDC_ANIMMODE);

    CString cstrTxt;
    
    lpButton->GetWindowText(cstrTxt);

    if(cstrTxt == _T("Manual"))
        {
        lpButton->SetWindowText(_T("Automatic"));
        m_boAutomaticAnim = true;
        }
    else
        {
        lpButton->SetWindowText(_T("Manual"));
        m_boAutomaticAnim = false;
        }

    if(m_lpDataEdit) m_lpDataEdit->vSetAutomaticAnim(m_boAutomaticAnim);
}


void CToolboxMoveable::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
    CString s;

    int iCtrlId = pScrollBar->GetDlgCtrlID();

    switch(nSBCode)
        {
        case TB_THUMBPOSITION:
        case TB_PAGEDOWN:
        case TB_PAGEUP:
        case TB_THUMBTRACK:
            {
            CSliderCtrl* lpSlider = reinterpret_cast<CSliderCtrl*>(pScrollBar);

            int nPos = lpSlider->GetPos();

            switch(iCtrlId)
                {
                case IDC_SLIDERFRAME:
                    {
                    if(m_boAutomaticAnim) break;
                    m_lpDataEdit->vSetAnimCurFrame(nPos - 1);
                    break;
                    }
                case IDC_SLIDERKEY:
                    {
                    if(m_boAutomaticAnim) break;
                    m_lpDataEdit->vSetAnimCurKey(nPos - 1);
                    break;
                    }
                case IDC_SLIDERSPEED:
                    {
                    m_dwAnimSpeed = nPos;
                    m_lpDataEdit->vSetAnimOverallSpeed(m_dwAnimSpeed / 100.0f);
                    s.Format(_T("%ld"),m_dwAnimSpeed);
                    CWnd* lpWnd = GetDlgItem(IDC_ANIMOVERALLSPEED);
                    lpWnd->SetWindowText(s);
                    break;
                    }
                }
            break;
            }
        }

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}


void CToolboxMoveable::OnInterpon() 
{
    CWnd* lpWnd = GetDlgItem(IDC_INTERP);
    lpWnd->SetFocus();

	CButton* lpButton = (CButton*)GetDlgItem(IDC_INTERPON);

    CString cstrTxt;
    
    lpButton->GetWindowText(cstrTxt);

    if(cstrTxt == _T("off"))
        {
        lpButton->SetWindowText(_T("on"));
        m_boAnimInterp = true;
        }
    else
        {
        lpButton->SetWindowText(_T("off"));
        m_boAnimInterp = false;
        }

    if(m_lpDataEdit) m_lpDataEdit->vSetAnimInterp(m_boAnimInterp);
}


void CToolboxMoveable::OnDeltaposSpininterp(NMHDR* pNMHDR, LRESULT* pResult) 
{
    if(m_boAutomaticAnim) return;

	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;

    if(m_lpDataEdit) m_lpDataEdit->vChangeAnimInterp(-pNMUpDown->iDelta > 0 ? 1 : -1);
    	
	*pResult = 0;
}


void CToolboxMoveable::OnKillfocusInterp() 
{
	UpdateData(TRUE);

    if(m_lpDataEdit) m_lpDataEdit->vSetAnimInterp(m_fAnimInterp);
}


void CToolboxMoveable::OnKillfocusObjId() 
{
    CTrMvb*   lpMoveable = m_lpDataHandler ? m_lpDataHandler->GetMoveable() : NULL;

    if(!lpMoveable) return;

	UpdateData(TRUE);

    lpMoveable->vSetObjectId(_ttol(m_cstrObjId));
}


void CToolboxMoveable::OnHexdec() 
{
	CButton* lpButton = (CButton*)GetDlgItem(IDC_HEXDEC);

    CString cstrTxt;
    
    lpButton->GetWindowText(cstrTxt);

    if(cstrTxt == _T("Dec"))
        {
        lpButton->SetWindowText(_T("Hex"));
        m_boAnmParamsInHexa = true;
        }
    else
        {
        lpButton->SetWindowText(_T("Dec"));
        m_boAnmParamsInHexa = false;
        }

    vSetAnimParams();

    UpdateData(FALSE);
}


void CToolboxMoveable::OnKillfocusAnmParam1() 
{
    CTrMvb*   lpMoveable = m_lpDataHandler ? m_lpDataHandler->GetMoveable() : NULL;

    if(!lpMoveable) return;

    CAnimMgr*       lpAnimMgr = lpMoveable->lpGetAnimMgr();
    DWORD           dwCurAnim = _ttol(m_cstrCurAnim); if(dwCurAnim) dwCurAnim--;
    CTRAnimTrack*   lpTrack = static_cast<CTRAnimTrack*>(lpAnimMgr->lpGetCurrentTrack());

	UpdateData(TRUE);

	if(m_boAnmParamsInHexa)
        {
        sscanf(m_cstrAnmUnk,"%x",&m_lAnmUnk);
        lpTrack->vSetPlayParams(m_lAnmUnk,m_lAnmSpeed,m_fAnmAccel);
        vSetAnimParams();
        UpdateData(FALSE);
        }
    else
        {
        m_lAnmUnk = _ttol(m_cstrAnmUnk);
        lpTrack->vSetPlayParams(m_lAnmUnk,m_lAnmSpeed,m_fAnmAccel);
        }
}

void CToolboxMoveable::OnKillfocusAnmParam2() 
{
    CTrMvb*   lpMoveable = m_lpDataHandler ? m_lpDataHandler->GetMoveable() : NULL;

    if(!lpMoveable) return;

    CAnimMgr*       lpAnimMgr = lpMoveable->lpGetAnimMgr();
    DWORD           dwCurAnim = _ttol(m_cstrCurAnim); if(dwCurAnim) dwCurAnim--;
    CTRAnimTrack*   lpTrack = static_cast<CTRAnimTrack*>(lpAnimMgr->lpGetCurrentTrack());

	UpdateData(TRUE);

    m_lAnmSpeed = _ttol(m_cstrAnmSpeed);
    lpTrack->vSetPlayParams(m_lAnmUnk,m_lAnmSpeed,m_fAnmAccel);
}

void CToolboxMoveable::OnKillfocusAnmParam3() 
{
    CTrMvb*   lpMoveable = m_lpDataHandler ? m_lpDataHandler->GetMoveable() : NULL;

    if(!lpMoveable) return;

    CAnimMgr*       lpAnimMgr = lpMoveable->lpGetAnimMgr();
    DWORD           dwCurAnim = _ttol(m_cstrCurAnim); if(dwCurAnim) dwCurAnim--;
    CTRAnimTrack*   lpTrack = static_cast<CTRAnimTrack*>(lpAnimMgr->lpGetCurrentTrack());

	UpdateData(TRUE);

    m_fAnmAccel = atof(m_cstrAnmAccel);
    lpTrack->vSetPlayParams(m_lAnmUnk,m_lAnmSpeed,m_fAnmAccel);
}


void CToolboxMoveable::OnKillfocusNextAnim() 
{
    CTrMvb*   lpMoveable = m_lpDataHandler ? m_lpDataHandler->GetMoveable() : NULL;

    if(!lpMoveable) return;

    CAnimMgr*       lpAnimMgr = lpMoveable->lpGetAnimMgr();
    DWORD           dwCurAnim = _ttol(m_cstrCurAnim); if(dwCurAnim) dwCurAnim--;
    CTRAnimTrack*   lpTrack = static_cast<CTRAnimTrack*>(lpAnimMgr->lpGetCurrentTrack());

	UpdateData(TRUE);

    lpAnimMgr->vSetNextTrack(lpAnimMgr->dwGetCurrentTrack(),m_dwNextAnim - 1,NO_CHANGE);
    lpAnimMgr->vSetChainTracks(m_boChainAnimations);
}


void CToolboxMoveable::OnKillfocusNextFrame() 
{
    CTrMvb*   lpMoveable = m_lpDataHandler ? m_lpDataHandler->GetMoveable() : NULL;

    if(!lpMoveable) return;

    CAnimMgr*       lpAnimMgr = lpMoveable->lpGetAnimMgr();
    DWORD           dwCurAnim = _ttol(m_cstrCurAnim); if(dwCurAnim) dwCurAnim--;
    CTRAnimTrack*   lpTrack = static_cast<CTRAnimTrack*>(lpAnimMgr->lpGetCurrentTrack());

	UpdateData(TRUE);

    lpAnimMgr->vSetNextTrack(lpAnimMgr->dwGetCurrentTrack(),NO_CHANGE,m_dwNextFrame - 1);
    lpAnimMgr->vSetChainTracks(m_boChainAnimations);
}


DWORD   CToolboxMoveable::dwGetCurTrack()
{
    return _ttol(m_cstrCurAnim);
}


//
//
// Anim dispatch
//
//
void CToolboxMoveable::vShowAnimDispatch( CTRAnimTrack* lpTrack, DWORD dwStateId_, DWORD dwFrameLo_, DWORD dwFrameHi_, DWORD dwNextAnm_, DWORD dwNextFrm_, DWORD& dwItem )
{
    m_AnimDispatch.DeleteAllItems();

    DWORD dwIndex = 0;

    for(DWORD dwI = 0; dwI < lpTrack->dwGetNumStateChanges(); dwI++)
        {
        CString s;
        const CTRStateChange&   StateChange = lpTrack->GetStateChange(dwI);

        for(DWORD dwJ = 0; dwJ < StateChange.dwGetNumAnimDispatch(); dwJ++)
            {
            DWORD   dwTag;
            const   CTRAnimDispatch& AnimDispatch = StateChange.GetAnimDispatch(dwJ, dwTag, false);
            DWORD   dwStateId = StateChange.dwGetStateId();

            s.Format(_T("%ld"),dwStateId);

            int iItem = m_AnimDispatch.InsertItem(dwIndex++,s);

            m_AnimDispatch.SetItemData(iItem,(dwStateId << 16) + dwTag);

            DWORD dwStartFrame, dwEndFrame, dwNextAnim, dwNextFrame;

            AnimDispatch.vGetFrameRange(dwStartFrame, dwEndFrame);
            AnimDispatch.vGetNextAnim(dwNextAnim, dwNextFrame);

            if( dwStateId == dwStateId_  &&  dwFrameLo_ == dwFrameLo_  &&  dwFrameHi_ == dwFrameHi_  &&  dwNextAnm_ == dwNextAnm_  &&  dwNextFrm_ == dwNextFrm_ ) dwItem = iItem;

            s.Format(_T("%ld"),dwStartFrame + 1);   m_AnimDispatch.SetItemText(iItem,1,s);
            s.Format(_T("%ld"),dwEndFrame + 1);     m_AnimDispatch.SetItemText(iItem,2,s);
            s.Format(_T("%ld"),dwNextAnim + 1);     m_AnimDispatch.SetItemText(iItem,3,s);
            s.Format(_T("%ld"),dwNextFrame + 1);    m_AnimDispatch.SetItemText(iItem,4,s);
            }
        }
}


void CToolboxMoveable::OnAnmdispSet() 
{
    CTrMvb*   lpMoveable = m_lpDataHandler ? m_lpDataHandler->GetMoveable() : NULL;

    if(!lpMoveable) return;

    CAnimMgr*       lpAnimMgr = lpMoveable->lpGetAnimMgr();
    DWORD           dwCurAnim = _ttol(m_cstrCurAnim); if(dwCurAnim) dwCurAnim--;
    CTRAnimTrack*   lpTrack = static_cast<CTRAnimTrack*>(lpAnimMgr->lpGetCurrentTrack());

    UpdateData(TRUE);

    DWORD   dwNewStateId = m_lAnmDispP[0];
    DWORD   dwFrameLo = m_lAnmDispP[1] - 1;
    DWORD   dwFrameHi = m_lAnmDispP[2] - 1;
    DWORD   dwNextAnm = m_lAnmDispP[3] - 1;
    DWORD   dwNextFrm = m_lAnmDispP[4] - 1;

    if( dwFrameLo > dwFrameHi )
        {
        AfxMessageBox( _T("The low frame must be less or equal to the high frame !"), MB_ICONSTOP | MB_TOPMOST );
        return;
        }

    if( dwFrameHi >= lpTrack->dwGetNumFrames() )
        {
        CString s;
        s.Format( _T("Invalid high frame (%ld) : the animation has only %ld frames !"), dwFrameHi + 1, lpTrack->dwGetNumFrames() );
        AfxMessageBox( s, MB_ICONSTOP | MB_TOPMOST );
        return;
        }

    if( dwNextAnm >= lpAnimMgr->dwGetNumTracks() )
        {
        CString s;
        s.Format( _T("Invalid next animation (%ld) : there are only %ld animations for this moveable !"), dwNextAnm, lpAnimMgr->dwGetNumTracks() );
        AfxMessageBox( s, MB_ICONSTOP | MB_TOPMOST );
        return;
        }

    CTRAnimTrack*   lpTrackNext = static_cast<CTRAnimTrack*>( lpAnimMgr->lpGetTrack(dwNextAnm) );

    if( dwNextFrm >= lpTrackNext->dwGetNumFrames() )
        {
        CString s;
        s.Format( _T("Invalid next frame (%ld) : the animation %ld has only %ld frames !"), dwNextFrm + 1, dwNextAnm + 1, lpTrackNext->dwGetNumFrames() );
        AfxMessageBox( s, MB_ICONSTOP | MB_TOPMOST );
        return;
        }

    POSITION pos = m_AnimDispatch.GetFirstSelectedItemPosition();

    if(pos == NULL) return;
	
    int iItem = m_AnimDispatch.GetNextSelectedItem(pos);

    DWORD   dwData = m_AnimDispatch.GetItemData(iItem);
    DWORD   dwStateId = dwData >> 16;
    DWORD   dwTag = dwData & 0xFFFF;

    if( dwStateId == dwNewStateId )
        {
        DWORD            dwIndex;
        CTRAnimDispatch& AnimDisp = const_cast<CTRAnimDispatch&>(lpTrack->GetStateChangeFromStateId(dwStateId).GetAnimDispatch(dwTag,dwIndex,true));

        AnimDisp.vSetFrameRange( dwFrameLo, dwFrameHi );
        AnimDisp.vSetNextAnim( dwNextAnm, dwNextFrm );

        CString s;

        s.Format(_T("%ld"),m_lAnmDispP[1]); m_AnimDispatch.SetItemText(iItem,1,s);
        s.Format(_T("%ld"),m_lAnmDispP[2]); m_AnimDispatch.SetItemText(iItem,2,s);
        s.Format(_T("%ld"),m_lAnmDispP[3]); m_AnimDispatch.SetItemText(iItem,3,s);
        s.Format(_T("%ld"),m_lAnmDispP[4]); m_AnimDispatch.SetItemText(iItem,4,s);

        UpdateData(FALSE);
        }
    else
        {
        m_AnimDispatch.DeleteItem(iItem);
        lpTrack->vRemoveAnimDispatch( dwStateId, dwTag );

        CTRStateChange  StateChange( dwNewStateId );
        CTRAnimDispatch AnimDispatch( dwFrameLo, dwFrameHi, dwNextAnm, dwNextFrm );

        StateChange.vPushAnimDispatch( AnimDispatch );

        lpTrack->vPushStateChange( StateChange );

//!CString t;t.Format("%ld %ld",dwNewStateId, dwNewTag); AfxMessageBox(t);

        DWORD dwIndex = -1;

        vShowAnimDispatch( lpTrack, dwNewStateId, dwFrameLo, dwFrameHi, dwNextAnm, dwNextFrm, dwIndex );

        if( dwIndex != -1)
            {
            m_AnimDispatch.SetItemState( dwIndex, LVIS_SELECTED, LVIS_SELECTED );
            vFillAnimDispParams( dwIndex );
            }
        }
}


void CToolboxMoveable::OnClickAnimdispatch(NMHDR* pNMHDR, LRESULT* pResult) 
{
	*pResult = 0;

    CTrMvb*   lpMoveable = m_lpDataHandler ? m_lpDataHandler->GetMoveable() : NULL;

    if(!lpMoveable) return;

    CAnimMgr*       lpAnimMgr = lpMoveable->lpGetAnimMgr();
    DWORD           dwCurAnim = _ttol(m_cstrCurAnim); if(dwCurAnim) dwCurAnim--;
    CTRAnimTrack*   lpTrack = static_cast<CTRAnimTrack*>(lpAnimMgr->lpGetCurrentTrack());

    LPNMITEMACTIVATE lpItem = (LPNMITEMACTIVATE) pNMHDR;

    if(!lpItem  ||  lpItem->iItem == -1) return;

    vFillAnimDispParams( lpItem->iItem );
}


void CToolboxMoveable::vFillAnimDispParams( int iIndex )
{
    int             iParam = 0;

    while( iParam != 5)
        {
        TCHAR   szParam[ 16 + 1 ];

        m_AnimDispatch.GetItemText( iIndex, iParam, szParam, 16 );
        m_lAnmDispP[ iParam++ ] = _ttol( szParam );
        }

    UpdateData(FALSE);
}


void CToolboxMoveable::OnAnmDispDel() 
{
    CTrMvb*   lpMoveable = m_lpDataHandler ? m_lpDataHandler->GetMoveable() : NULL;

    if(!lpMoveable) return;

    CAnimMgr*       lpAnimMgr = lpMoveable->lpGetAnimMgr();
    CTRAnimTrack*   lpTrack = static_cast<CTRAnimTrack*>(lpAnimMgr->lpGetCurrentTrack());

    POSITION pos = m_AnimDispatch.GetFirstSelectedItemPosition();

    if(pos == NULL) return;
	
    int     iItem = m_AnimDispatch.GetNextSelectedItem(pos);
    DWORD   dwData = m_AnimDispatch.GetItemData(iItem);
    DWORD   dwStateId = dwData >> 16;
    DWORD   dwTag = dwData & 0xFFFF;

    m_AnimDispatch.DeleteItem(iItem);
    lpTrack->vRemoveAnimDispatch( dwStateId, dwTag );

    UpdateData( FALSE );

    if( iItem < m_AnimDispatch.GetItemCount() )
        {
        m_AnimDispatch.SetItemState( iItem, LVIS_SELECTED, LVIS_SELECTED );
        }
    else
        {
        m_AnimDispatch.SetItemState( m_AnimDispatch.GetItemCount() - 1, LVIS_SELECTED, LVIS_SELECTED );
        }
}


void CToolboxMoveable::OnAnmDispNew() 
{
    CTrMvb*   lpMoveable = m_lpDataHandler ? m_lpDataHandler->GetMoveable() : NULL;

    if(!lpMoveable) return;

    CAnimMgr*       lpAnimMgr = lpMoveable->lpGetAnimMgr();
    CTRAnimTrack*   lpTrack = static_cast<CTRAnimTrack*>(lpAnimMgr->lpGetCurrentTrack());

    CTRStateChange  StateChange(0);
    CTRAnimDispatch AnimDispatch( 0, 0, 0, 0 );

    StateChange.vPushAnimDispatch( AnimDispatch );

    lpTrack->vPushStateChange( StateChange );

    DWORD dwIndex;

    vShowAnimDispatch( lpTrack, 0, 0, 0, 0, 0, dwIndex );
    m_AnimDispatch.SetItemState( dwIndex, LVIS_SELECTED, LVIS_SELECTED );

    vFillAnimDispParams( dwIndex );
}


//
//
// Anim commands
//
//
void CToolboxMoveable::vShowAnimCommands( CTRAnimTrack* lpTrack )
{
    m_AnimCommands.DeleteAllItems();

    for(DWORD dwI = 0; dwI < lpTrack->dwGetNumAnimCommands(); dwI++)
        {
        CString s;
        const CTRAnimCommand& AnimCmde = lpTrack->GetAnimCommand(dwI);

        DWORD dwNumParams = AnimCmde.wGetNumParams();

        TR2_ANIM_COMMAND    sCmd = AnimCmde.sGetCommand();

        s.Format(_T("%ld"),static_cast<DWORD>(sCmd.sValue));

        int iItem = m_AnimCommands.InsertItem(dwI,s);

        bool boFirstParamIsFrame = CTRAnimCommand::boFirstParamIsFrame( sCmd );

        for(long l = 0; l < dwNumParams; l++)
            {
            TR2_ANIM_COMMAND sParam = AnimCmde.sGetParam(l);
            long    lValue =  sParam.sValue;

            if(l == 0  &&  boFirstParamIsFrame) lValue++;

            s.Format(_T("%ld"),lValue);
            m_AnimCommands.SetItemText(iItem,l+1,s);
            }
        }
}


void CToolboxMoveable::OnAnmcmdSet() 
{
    CTrMvb*   lpMoveable = m_lpDataHandler ? m_lpDataHandler->GetMoveable() : NULL;

    if(!lpMoveable) return;

    CAnimMgr*       lpAnimMgr = lpMoveable->lpGetAnimMgr();
    DWORD           dwCurAnim = _ttol(m_cstrCurAnim); if(dwCurAnim) dwCurAnim--;
    CTRAnimTrack*   lpTrack = static_cast<CTRAnimTrack*>(lpAnimMgr->lpGetCurrentTrack());

    POSITION pos = m_AnimCommands.GetFirstSelectedItemPosition();

    if(pos == NULL) return;
	
    int iItem = m_AnimCommands.GetNextSelectedItem(pos);

    CTRAnimCommand& AnimCmde = const_cast<CTRAnimCommand&>(lpTrack->GetAnimCommand(iItem));

    for( DWORD dwJ = 0; dwJ < 4; dwJ++)
        {
        CString s;
        GetDlgItem( IDC_ANMCMD_P1 + dwJ )->GetWindowText( s );
        if( s == _T("") ) s = _T("0");
        GetDlgItem( IDC_ANMCMD_P1 + dwJ )->SetWindowText( s );
        }

    UpdateData(TRUE);

    TR2_ANIM_COMMAND    sOldCmde = AnimCmde.sGetCommand();
    TR_FILE&            trFile = m_lpDataHandler->lpGetTRFile()->GetTRFile();

    if(m_lAnmCmdP[0] == ANIMCMD_PLAYSOUNDONFRAME_2)
        {
        if(!trFile.tr123File.lpSndMgr->boHaveSound(m_lAnmCmdP[2] & 0x3FFF))
            {
            CString s;
            s.Format(_T("Can't modify this anim command because the sound with internal index #%ld is not in the sound list !"),m_lAnmCmdP[2] & 0x3FFF);
            AfxMessageBox(s,MB_ICONSTOP | MB_TOPMOST);
            return;
            }
        }

    if(sOldCmde.sValue == ANIMCMD_PLAYSOUNDONFRAME_2)
        {
        lpMoveable->lpGetSndMgr()->vRemoveSound(AnimCmde.sGetParam(1).sValue & 0x3FFF);
        }

    CString s;

    AnimCmde.vSetCommand(TR2_ANIM_COMMAND(m_lAnmCmdP[0]));

    DWORD   dwNumParams = AnimCmde.wGetNumParams();
    bool    boFirstParamIsFrame = CTRAnimCommand::boFirstParamIsFrame( AnimCmde.sGetCommand() );

    s.Format(_T("%ld"),m_lAnmCmdP[0]);
    m_AnimCommands.SetItemText(iItem,0,s);

    for( DWORD dwI = dwNumParams; dwI < 3; dwI++)
        {
        m_AnimCommands.SetItemText( iItem, dwI + 1, _T("") );
        }

    while(dwNumParams--)
        {
        long    lValue =  m_lAnmCmdP[dwNumParams + 1];

        s.Format(_T("%ld"),lValue);
        m_AnimCommands.SetItemText(iItem,dwNumParams + 1,s);

        if(dwNumParams == 0  &&  boFirstParamIsFrame) lValue--;

        AnimCmde.vSetParam(dwNumParams, lValue);
        }

    if(m_lAnmCmdP[0] == ANIMCMD_PLAYSOUNDONFRAME_2)
        {
        lpMoveable->lpGetSndMgr()->boCopySound(trFile.tr123File.lpSndMgr, m_lAnmCmdP[2] & 0x3FFF);
        }

    UpdateData(FALSE);

    for( dwI = AnimCmde.wGetNumParams(); dwI < 3; dwI++)
        {
        GetDlgItem( IDC_ANMCMD_P1 + dwI + 1 )->SetWindowText( _T("") );
        }
}


void CToolboxMoveable::OnClickAnimcommands(NMHDR* pNMHDR, LRESULT* pResult) 
{
	*pResult = 0;

    CTrMvb*   lpMoveable = m_lpDataHandler ? m_lpDataHandler->GetMoveable() : NULL;

    if(!lpMoveable) return;

    CAnimMgr*       lpAnimMgr = lpMoveable->lpGetAnimMgr();
    DWORD           dwCurAnim = _ttol(m_cstrCurAnim); if(dwCurAnim) dwCurAnim--;
    CTRAnimTrack*   lpTrack = static_cast<CTRAnimTrack*>(lpAnimMgr->lpGetCurrentTrack());

    LPNMITEMACTIVATE lpItem = (LPNMITEMACTIVATE) pNMHDR;

    if(!lpItem  ||  lpItem->iItem == -1) return;

    vFillAnimCmdsParams( lpTrack, lpItem->iItem );
}


void CToolboxMoveable::vFillAnimCmdsParams( CTRAnimTrack* lpTrack, int iNumAnmCmde )
{
    CTRAnimCommand& AnimCmde = const_cast<CTRAnimCommand&>(lpTrack->GetAnimCommand(iNumAnmCmde));
    DWORD           dwNumParams = AnimCmde.wGetNumParams();
    int             iParam = 0;

    while( iParam != 4)
        {
        TCHAR   szParam[ 16 + 1 ];

        m_AnimCommands.GetItemText( iNumAnmCmde, iParam, szParam, 16 );
        m_lAnmCmdP[ iParam++ ] = _ttol( szParam );
        }

    UpdateData(FALSE);

    for(DWORD dwI = dwNumParams; dwI < 3; dwI++)
        {
        GetDlgItem( IDC_ANMCMD_P1 + dwI + 1 )->SetWindowText( _T("") );
        }
}


void CToolboxMoveable::OnAnmCmdDel() 
{
    CTrMvb*   lpMoveable = m_lpDataHandler ? m_lpDataHandler->GetMoveable() : NULL;

    if(!lpMoveable) return;

    CAnimMgr*       lpAnimMgr = lpMoveable->lpGetAnimMgr();
    CTRAnimTrack*   lpTrack = static_cast<CTRAnimTrack*>(lpAnimMgr->lpGetCurrentTrack());

    POSITION pos = m_AnimCommands.GetFirstSelectedItemPosition();

    if(pos == NULL) return;
	
    int iItem = m_AnimCommands.GetNextSelectedItem(pos);

    m_AnimCommands.DeleteItem(iItem);
    lpTrack->vRemoveAnimCommand( iItem );

    UpdateData( FALSE );

    if( iItem < m_AnimCommands.GetItemCount() )
        {
        m_AnimCommands.SetItemState( iItem, LVIS_SELECTED, LVIS_SELECTED );
        }
    else
        {
        m_AnimCommands.SetItemState( m_AnimCommands.GetItemCount() - 1, LVIS_SELECTED, LVIS_SELECTED );
        }
}


void CToolboxMoveable::OnAnmCmdUp() 
{
    CTrMvb*   lpMoveable = m_lpDataHandler ? m_lpDataHandler->GetMoveable() : NULL;

    if(!lpMoveable) return;

    CAnimMgr*       lpAnimMgr = lpMoveable->lpGetAnimMgr();
    CTRAnimTrack*   lpTrack = static_cast<CTRAnimTrack*>(lpAnimMgr->lpGetCurrentTrack());

    POSITION pos = m_AnimCommands.GetFirstSelectedItemPosition();

    if(pos == NULL) return;
	
    int iItem = m_AnimCommands.GetNextSelectedItem(pos);

    if(iItem > 0)
        {
        lpTrack->vSwapAnimCmde( iItem, iItem - 1 );
        vMoveItem( m_AnimCommands, 4, -1 );
        UpdateData( FALSE );
        }
}


void CToolboxMoveable::OnAnmCmdDown() 
{
    CTrMvb*   lpMoveable = m_lpDataHandler ? m_lpDataHandler->GetMoveable() : NULL;

    if(!lpMoveable) return;

    CAnimMgr*       lpAnimMgr = lpMoveable->lpGetAnimMgr();
    CTRAnimTrack*   lpTrack = static_cast<CTRAnimTrack*>(lpAnimMgr->lpGetCurrentTrack());

    POSITION pos = m_AnimCommands.GetFirstSelectedItemPosition();

    if(pos == NULL) return;
	
    int iItem = m_AnimCommands.GetNextSelectedItem(pos);

    if(iItem < m_AnimCommands.GetItemCount() - 1 )
        {
        lpTrack->vSwapAnimCmde( iItem, iItem + 1 );
        vMoveItem( m_AnimCommands, 4, 2 );
        UpdateData( FALSE );
        }
}


void CToolboxMoveable::OnAnmCmdNew() 
{
    CTrMvb*   lpMoveable = m_lpDataHandler ? m_lpDataHandler->GetMoveable() : NULL;

    if(!lpMoveable) return;

    CAnimMgr*       lpAnimMgr = lpMoveable->lpGetAnimMgr();
    CTRAnimTrack*   lpTrack = static_cast<CTRAnimTrack*>(lpAnimMgr->lpGetCurrentTrack());

    CTRAnimCommand  AnimCmde( ANIMCMD_DEATHANIM_0, 0 );

    lpTrack->vPushAnimCommand( AnimCmde );

    vShowAnimCommands( lpTrack );

    m_AnimCommands.SetItemState(m_AnimCommands.GetItemCount() - 1,LVIS_SELECTED,LVIS_SELECTED);

    vFillAnimCmdsParams( lpTrack, m_AnimCommands.GetItemCount() - 1 );
}


void CToolboxMoveable::vMoveItem( CListCtrl& ListCtrl, int iNumSubItems, int iOffset )
{
    int iIndex = -1;
    do
        {
        iIndex = ListCtrl.GetNextItem(iIndex,LVNI_SELECTED);
        if(iIndex == -1) break;

        // Check we don't move the first (if we move up) / the last element (if we move down)
        if((iIndex+iOffset >= 0)  &&  (iIndex+iOffset <= ListCtrl.GetItemCount()))
            {
            TCHAR**  lpListTexts = new TCHAR* [ iNumSubItems ];

            for( int i = 0; i < iNumSubItems; i++)
                {
                lpListTexts[ i ] = new TCHAR[ 128 + 1 ];
                ListCtrl.GetItemText(iIndex,i,lpListTexts[ i ],128);
                }

            int iNewIndex = ListCtrl.InsertItem(iIndex+iOffset,lpListTexts[ 0 ]);

            for( i = 1; i < iNumSubItems; i++)
                {
                ListCtrl.SetItemText(iNewIndex,i,lpListTexts[ i ]);
                delete [] lpListTexts[ i ];
                }

            delete [] lpListTexts;

            ListCtrl.SetItemState(iNewIndex,LVIS_SELECTED,LVIS_SELECTED);
            ListCtrl.DeleteItem(iOffset > 0 ? iIndex : iIndex+1);
            }
        break;
        }
    while(true);
}
