#if !defined(AFX_TOOLBOXMOVEABLE_H__E693D551_1EB0_11D4_AA77_00105A49000B__INCLUDED_)
#define AFX_TOOLBOXMOVEABLE_H__E693D551_1EB0_11D4_AA77_00105A49000B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ToolboxMoveable.h : header file
//

#include "Toolbox.h"

/////////////////////////////////////////////////////////////////////////////
// CToolboxMoveable dialog

class CHandleMoveable;
class CEditMoveable;
class CTRAnimTrack;

class CToolboxMoveable : public CToolbox
{
// Construction
public:
	CToolboxMoveable(CWnd* pParent = NULL);   // standard constructor
    ~CToolboxMoveable();

// Dialog Data
	//{{AFX_DATA(CToolboxMoveable)
	enum { IDD = IDD_TOOLBOX_MOVEABLE };
	CListCtrl	m_AnimDispatch;
	CSliderCtrl	m_SliderSpeed;
	CSpinButtonCtrl	m_SpinInterp;
	CSliderCtrl	m_SliderKey;
	CSliderCtrl	m_SliderFrame;
	CComboBox	m_LstAnims;
	CString	m_cstrObjId;
	CString	m_cstrMvblExtents;
	CString	m_cstrCurAnim;
	CString	m_cstrCurFrame;
	DWORD	m_dwAnimFrameRate;
	CString	m_cstrNumTotFrames;
	CString	m_cstrCurKey;
	CString	m_cstrNumTotKeys;
    DWORD   m_dwAnimSpeed;
	float	m_fAnimInterp;
	CString	m_cstrStateId;
    CString	m_cstrAnmUnk;
    CString	m_cstrAnmSpeed;
    CString	m_cstrAnmAccel;
	CListCtrl	m_AnimCommands;
	long	m_lAnmCmdP[4];
    DWORD   m_dwNextAnim;
    DWORD   m_dwNextFrame;
	long	m_lAnmDispP[5];
	//}}AFX_DATA

// Operations
public:

    void    vSetDataTypeHandler(CHandleMoveable* lpHandler,CEditMoveable* lpEdit,bool boForceNewMoveable = false);
    void    vRefreshExtents(bool boUpdateData = true);
    void    vSetCurAnim(DWORD dwCurAnim);
    void    vSetCurFrame(DWORD dwCurFrame,DWORD dwNumFrames);
    void    vSetCurKey(DWORD dwCurKey,DWORD dwNumKeys);
    void    vSetAnimationFrameRate(DWORD dwAnimFrameRate);
    void    vSetAnimationNextAnim(DWORD dwNextAnim,DWORD dwNextFrame);
    void    vSetInterp(float fInterp);
    bool    boIsAnimModeAutomatic() { return m_boAutomaticAnim; }
    void    vShowAnimCommands( CTRAnimTrack* lpTrack );
    void    vShowAnimDispatch( CTRAnimTrack* lpTrack, DWORD dwStateId_, DWORD dwFrameLo_, DWORD dwFrameHi_, DWORD dwNextAnm_, DWORD dwNextFrm_, DWORD& dwItem );

    DWORD   dwGetCurTrack();
    
    void    vMoveItem( CListCtrl& ListCtrl, int iNumSubItems, int iOffset );
    void    vFillAnimCmdsParams( CTRAnimTrack* lpTrack, int iNumAnmCmde );
    void    vFillAnimDispParams( int iIndex );

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CToolboxMoveable)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

    void    vSetAnimParams();

	// Generated message map functions
	//{{AFX_MSG(CToolboxMoveable)
	afx_msg void OnClose();
	afx_msg void OnSelchangeComboanim();
	afx_msg void OnTypeanim();
	afx_msg void OnAnimmode();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnInterpon();
	afx_msg void OnDeltaposSpininterp(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnKillfocusInterp();
	afx_msg void OnKillfocusObjId();
	virtual BOOL OnInitDialog();
	afx_msg void OnHexdec();
	afx_msg void OnKillfocusAnmParam1();
	afx_msg void OnKillfocusAnmParam2();
	afx_msg void OnKillfocusAnmParam3();
	afx_msg void OnAnmcmdSet();
	afx_msg void OnClickAnimcommands(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnKillfocusNextAnim();
	afx_msg void OnKillfocusNextFrame();
	afx_msg void OnAnmdispSet();
	afx_msg void OnClickAnimdispatch(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnKillfocusStateId();
	afx_msg void OnAnmCmdNew();
	afx_msg void OnAnmCmdDel();
	afx_msg void OnAnmCmdUp();
	afx_msg void OnAnmCmdDown();
	afx_msg void OnAnmDispDel();
	afx_msg void OnAnmDispNew();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:

    CHandleMoveable*    m_lpDataHandler;
    CEditMoveable*      m_lpDataEdit;
    bool                m_boChainAnimations;
    bool                m_boAutomaticAnim;
    bool                m_boAnimInterp;
    bool                m_boAnmParamsInHexa;
    long                m_lAnmUnk;
    long                m_lAnmSpeed;
    float               m_fAnmAccel;
    HBITMAP             m_hBitmapNew;
    HBITMAP             m_hBitmapDel;
    HBITMAP             m_hBitmapUp;
    HBITMAP             m_hBitmapDown;
    HBITMAP             m_hBitmapValidate;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TOOLBOXMOVEABLE_H__E693D551_1EB0_11D4_AA77_00105A49000B__INCLUDED_)
